  Const
    MaxN = 100;
    eps = 1e-4;

  Var
    N, E: Integer;
    Ras: Array [1..MaxN, 1..MaxN] Of Real;
    Was: Array [1..MaxN] Of Boolean;

    Rs: Real;
    Res,x,y,i,j: Integer;

  Function Eq(a,b: Real): Boolean;
  Begin
    Eq := Abs(a-b) < eps;
  End;

  Function Less(a,b: Real): Boolean;
  Begin
    Less := (a-b) <= -eps;
  End;


  Function Sign(x: Integer): Integer;
  Begin
    If x > 0 Then Sign := 1 Else
    If x = 0 Then Sign := 0 Else Sign := -1;
  End;

  {at first x<y}
  Function GetRas(x,y: Integer): Real;
    Var i: Integer; Rs: Real;
  Begin
    Rs := -1;
    Was[x] := True;
    If Not Eq(Ras[x,y], -1) Then GetRas := sign(y-x)*Ras[x,y] Else
     Begin
       i := 1;
       While (i <= N) And Eq(Rs, -1) Do
        Begin
          If Not Was[i] And Not Eq(Ras[x,i], -1) Then
            Rs := GetRas(i,y);
          inc(i);
        End;
       If (i <= N) Then
        Begin
          dec(i);
          Ras[x,y] := sign(i-x)*Ras[x,i] + Rs;
          GetRas := Ras[x,y];
          Ras[x,y] := Abs(Ras[x,y]);
        End
       Else GetRas := -1;
     End;
  End;

  Procedure Solve;
    Var i,j: Integer;
        Br, R: Real;
  Begin
    For i := 2 To N Do
     Begin
       FillChar(Was, Sizeof(Was), False);
       Ras[i-1, i] := GetRas(i-1,i);
       If Eq(Ras[i-1,i], -1) Then Begin Res := 2; Exit End;
       If Less(Ras[i-1,i], 0) Then Begin Res := 2; Exit End;
     End;
    {checking}
    For i := 1 To N-1 Do
     Begin
       R := 0;
       For j := i+1 To N Do
        Begin
          R := R + Ras[j-1,j];
          If (Not Eq(R, Ras[i,j]) And Not Eq(Ras[i,j], -1)) Or
             (Not Eq(R, Ras[j,i]) And Not Eq(Ras[j,i], -1))
		   Then Begin Res := 2; Exit End;
        End;
     End;
  End;

Begin
  Assign(input, 'station.dat'); Reset(input);
    Read(N, E);
    For i := 1 To N Do
     For j := 1 To N Do Ras[i,j] := -1;
    Res := 1;
    For i := 1 To E Do
     Begin
       Read(x, y, rs);
       If (x=y) Then
        Begin
          If Not Eq(rs,0) Then Res := 2;
        End
       Else
	    Begin
		  If Not Eq(Ras[x,y],-1) And Not Eq(Ras[x,y],rs) Then Res := 2
		    Else Ras[x,y] := rs;
		  If Not Eq(Ras[y,x],-1) And Not Eq(Ras[y,x],rs) Then Res := 2
		    Else Ras[y,x] := rs;
        End;
     End;
  Close(input);

  If Res <> 2 Then Solve;

  Assign(output, 'station.sol'); Rewrite(output);
    WriteLn(Res);
    If Res = 1 Then
      Begin
        For i := 2 To N-1 Do
         Write(Ras[i-1,i]:0:3, ' ');
        WriteLn(Ras[N-1,N]:0:3);
      End;
  Close(output);
End.